unit ClientForm;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, DB, DBClient, MConnect, StdCtrls;

type
  TForm1 = class(TForm)
    DCOMConnection1: TDCOMConnection;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    btnConnect: TButton;
    btnApplyUpdates: TButton;
    procedure btnConnectClick(Sender: TObject);
    procedure ClientDataSet1BeforeGetRecords(Sender: TObject;
      var OwnerData: OleVariant);
    procedure btnApplyUpdatesClick(Sender: TObject);
    procedure ClientDataSet1ReconcileError(DataSet: TCustomClientDataSet;
      E: EReconcileError; UpdateKind: TUpdateKind;
      var Action: TReconcileAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.dfm}

procedure TForm1.btnConnectClick(Sender: TObject);
begin
  if (Sender as TButton).Caption = 'Connect' then
  begin
    ClientDataSet1.Active := True;
    (Sender as TButton).Caption := 'Disconnect'
  end
  else
  begin
    ClientDataSet1.Active := False;
    ClientDataSet1.RemoteServer.Connected := False; // also disconnect
    (Sender as TButton).Caption := 'Connect'
  end
end;

procedure TForm1.ClientDataSet1BeforeGetRecords(Sender: TObject;
  var OwnerData: OleVariant);
begin
  with Sender as TClientDataSet do
    if Active then
      OwnerData := IntToStr(RecordCount)
end;


procedure TForm1.btnApplyUpdatesClick(Sender: TObject);
begin
  try
    try
      (Sender AS TButton).Enabled := False;
      ClientDataSet1.ApplyUpdates(0)
    finally
      (Sender AS TButton).Enabled := True
    end
  except
    on E: Exception do
      ShowMessage('ApplyUpdates Error: ' + E.Message)
  end
end;

procedure TForm1.ClientDataSet1ReconcileError(
  DataSet: TCustomClientDataSet; E: EReconcileError;
  UpdateKind: TUpdateKind; var Action: TReconcileAction);
begin
  ShowMessage('Reconcile Error: ' + E.Message);
end;

end.
