unit RDataMod;
{$WARN SYMBOL_PLATFORM OFF}
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComServ, ComObj, VCLCom, StdVcl, bdemts, DataBkr, DBClient,
  MtsRdm, Mtx, TDM84_TLB, DBXpress, FMTBcd, Provider, DB, SqlExpr;

type
  TDataSnapTDM84 = class(TMtsDataModule, IDataSnapTDM84)
    SQLConnection1: TSQLConnection;
    SQLDataSet1: TSQLDataSet;
    dspPHONE_LIST: TDataSetProvider;
    SQLDataSet1EMP_NO: TSmallintField;
    SQLDataSet1FIRST_NAME: TStringField;
    SQLDataSet1LAST_NAME: TStringField;
    SQLDataSet1PHONE_EXT: TStringField;
    SQLDataSet1LOCATION: TStringField;
    SQLDataSet1PHONE_NO: TStringField;
    SQLDataSet2: TSQLDataSet;
    dspCUSTOMER: TDataSetProvider;
    procedure dspPHONE_LISTBeforeGetRecords(Sender: TObject;
      var OwnerData: OleVariant);
    procedure dspCUSTOMERUpdateData(Sender: TObject;
      DataSet: TCustomClientDataSet);
  private
    { Private declarations }
  protected
    class procedure UpdateRegistry(Register: Boolean; const ClassID, ProgID: string); override;
  public
    { Public declarations }
  end;

var
  DataSnapTDM84: TDataSnapTDM84;

implementation
{$R *.DFM}

class procedure TDataSnapTDM84.UpdateRegistry(Register: Boolean; const ClassID, ProgID: string);
begin
  if Register then
  begin
    inherited UpdateRegistry(Register, ClassID, ProgID);
    EnableSocketTransport(ClassID);
    EnableWebTransport(ClassID);
  end else
  begin
    DisableSocketTransport(ClassID);
    DisableWebTransport(ClassID);
    inherited UpdateRegistry(Register, ClassID, ProgID);
  end;
end;

procedure TDataSnapTDM84.dspPHONE_LISTBeforeGetRecords(Sender: TObject;
  var OwnerData: OleVariant);
var
  Str: String;
begin
  Str := OwnerData;
  with Sender as TDataSetProvider do
  begin
    if DataSet.Active then DataSet.First
                      else DataSet.Open;
    if Str <> '' then
      DataSet.MoveBy(StrToIntDef(Str,0))
  end
end;

procedure TDataSnapTDM84.dspCUSTOMERUpdateData(Sender: TObject;
  DataSet: TCustomClientDataSet);
begin
  if IsSecurityEnabled then
    if not IsCallerInRole('Maintainer') then
      raise Exception.Create('ApplyUpdates only allowed for Maintainer role!');
end;           

initialization
  TComponentFactory.Create(ComServer, TDataSnapTDM84,
    Class_DataSnapTDM84, ciMultiInstance, tmApartment);
end.